#include "commonfile.h"
#include "fan.h"
#include "main.h"
#include "one_wire_stm.h"
#include "pwm.h"

uint32_t FanState;
int32_t TimeSpinUp;

//---------------------COOLER---------------------------
void calculation_step_U(void){
int32_t DeltaU;
int32_t DeltaT;
uint32_t StepU;
	DeltaU=S.Fan.UHi-S.Fan.ULow;
	DeltaT=S.Fan.THi-S.Fan.TLow;
	StepU= (DeltaU*100) / DeltaT;
	S.Fan.Step=StepU;
}

static uint32_t calc_power_fan(void){
int32_t DeltaT;
int32_t Power=S.Fan.UHi;
	
	//if ( PinWireDS[T_VT] & Power1w )
	//{
	if ( (Temperaturs[T_VT]) <= S.Fan.THi )
		{
		DeltaT=(Temperaturs[T_VT]) - S.Fan.TLow;
		if ( DeltaT>0 )
			{
			Power= (DeltaT*S.Fan.Step)/100+S.Fan.ULow;
			}
		else
		if ( (DeltaT>=-5) && ((FanState & FAN_POWER_OFF)==0) ){
			Power=S.Fan.ULow;
			}
		else{
			if (S.Fan.OffTLo){
				Power=0;
				FanState|= FAN_POWER_OFF;
				}
				else
				Power=S.Fan.ULow;
			}
		}
	//}
	return Power;
}

static void fan_power_off(void){
	pwm_fan_off();
}

static void fan_power_on(void){
	pwm_fan_on();
}

uint32_t control_fan(uint32_t Manual_U){
uint32_t Power;
	
	if (Manual_U) {
		Power=Manual_U;
		fan_power_on();
		}
	else{
	
	Power=calc_power_fan();
	
	if ( Power )//   
		{
		fan_power_on();// 
		if ( FanState & FAN_POWER_OFF)//   
			{
			FanState|= FAN_EVENT_POWER_ON; 	//   
			FanState&= ~FAN_POWER_OFF; //   
			TimeSpinUp=S.Fan.TimSpinUp*100;//   (0.1s*T)
			}
		if ( FanState & FAN_EVENT_POWER_ON )//       U 
			{
			Power=S.Fan.USpinUp;
			}
		}
		else//    
		{
		if ( FanState & FAN_POWER_OFF){
			fan_power_off();
			}
		}
	}
	return Power;
}


//-------------------------------------------------------------------------------------------------------
