
#include "stm32f10x.h"


/*
1 gnd
2 vcc
3 Vo
4 RS
-no	5 RW
6 E
11 DB4
12 DB5
13 DB6
14 DB7
*/

//   !     !

//extern void 		lcd_4bus_write(uint8_t data);//   4  ,   RS=RW=0,  DB3..0 = 0    Z   
//extern uint8_t 		lcd_read_byte(void);//  , RS=RW=0,  DB3..0 = 0    Z 
//extern uint8_t 	read_busy_address(void);
extern void 		lcd_write_data(uint8_t data);//write data to CGRAM or DDRAM
extern void 		lcd_instructions_set(uint8_t address);
extern void			lcd_init(void);
extern void			lcd_set_address(uint8_t x, uint8_t y);


//---------------------------------------------
//  lcd  !    
#define BUSY_FLAG					0x80
#define CLEAR_DISPLAY				0x01 //1.5mS  .       
#define RETURN_HOME					0x02 //40uS     
//---------Entry mode set--------------- //40uS        
#define	INC_AC						0x06
//#define inc_AC_display_shift_richt	0x05
#define DEC_AC						0x04
//#define dec_AC_display_shift_left	0x07
//---------Display control--------------
#define DISPLAY_OFF					0x08
#define DISPLAY_ON					0x0C
#define CURSOR_OFF					0x0C		
#define CURSOR_LINES				0x0E
#define CURSOR_LIN_BLINKS			0x0F 
#define CURSOR_BLINKS				0x0D 
//---------Cursor/display shift---------
#define SHIFT_CURSOR_LEFT			0x10
#define SHIFT_CURSOR_RICHT			0x14
#define SHIFT_DISPLAY_LEFT			0x18
#define SHIFT_DISPLAY_RICHT			0x1C
//--------------Function set------------
//--------------------------------------

#define SET_CGRAM_ADDRESS				0x40 //max 63
#define SET_DDRAM_ADDRESS				0x80 //max 127


/* 9.     IR
		8	4	2	1	8	4	2	1
RS	RW	D7	D6	D5	D4	D3	D2	D1	D0	
--------------------------------------------------------------------------------------------------------------------- 
0	0 |	0 	0	0	0	0	0	0	1	 ,  = 0,    DDRAM			//Clear display  
0	0 |	0	0	0	0	0	0	1	-	 = 0,   DDRAM,  ,      DDRAM //Return Home
0	0 |	0	0	0	0	0	1	I/D	S 	      		//Entry mode set
0	0 |	0	0	0	0	1	D	C	B	  							//Display control
0	0 |	0	0	0	1	S/C	R/L	-	-	  /							//Cursor/display shift  
0	0 |	0	0	1	DL	N	F	-	-	       	//Function set
0	0 |	0	1	AG	AG	AG	AG	AG	AG	      CGRAM 			//Set CGRAM address
0	0 |	1	AD	AD	AD	AD	AD	AD	AD	      DDRAM			//Set DDRAM address
0	1 |	BF			AC					Read busy flag and address
1	1 |			Read data				Reads data from CGRAM or DDRAM.
1	0 |			Write data				Writes data to CGRAM or DDRAM.
---------------------------------------------------------------------------------------------------------------------  
*/
/*
 7. ,    HD44780
--------------------------------------------------------------------------------------------------------------------- 
I/D:	    , 0 - , 1 - .
---------------------------------------------------------------------------------------------------------------------  
S:		    . 0 -    , 
		1 -    DDRAM      , 
		  I/D: 0 - , 1 - .    
		  DDRAM.     
		    DDRAM.
---------------------------------------------------------------------------------------------------------------------  
S/C:	-,     R/L     
		( ,     ,    DDRAM)  . 
		 : 0 -  , 1 -  . 
--------------------------------------------------------------------------------------------------------------------- 
R/L:	-,     S/C     . 
		  : 0 - , 1 - . 
--------------------------------------------------------------------------------------------------------------------- 
D/L:	,    : 0 - 4 , 1 - 8 . 
--------------------------------------------------------------------------------------------------------------------- 
N:		    : 0 -  , 1 -   
--------------------------------------------------------------------------------------------------------------------- 
F:		  : 0 - 5  8 , 1 - 5  10 . 
--------------------------------------------------------------------------------------------------------------------- 
D:		 : 0 - , 1 -  
--------------------------------------------------------------------------------------------------------------------- 
:		   : 0 - , 1 -  
--------------------------------------------------------------------------------------------------------------------- 
:		    : 0 - , 1 - . 
--------------------------------------------------------------------------------------------------------------------- 
*/

/*
     = 0,  R/W = 0,   RS - ,
  DBO...DB7     (I). 
    (E  R/W)      
     -
*/
/*
  (DR),   (IR),  (DDRAM),   (CGRAM), 
   (),   .
 RS = 0 -    (IR),  RS = 1 -   (DR).
R/W = 1 - ; R/W = 0 -  

 (DDRAM) - 2   40 
*/
/*
 1.    8-  
	   RS 
	       DB0...DB7 
	   = 1 
	  E = 0 
	   DB0...DB7 = HI 
 2.    8-  
	   RS 
	  R/W = 1 
	   = 1 
	       DB0...DB7 
	   = 0 
	  R/W = 0 
//-----------------------------------------------------------------------

 3.    4-  
	   RS 
	         DB4...DB7 
	   = 1 
	   = 0 
	         DB4...DB7 
	   = 1 
	   = 0 
	   DB4...DB7 = HI 
 4.    4-  
	   RS 
	  R/W = 1 
	   = 1 
	         DB4...DB7 
	   = 0 
	   = 1 
	         DB4...DB7 
	   = 0 
	  R/W = 0 
*/

