//	startcd.narod.ru
/*
-pSTM32F103RB
stm32f100c4t6b

DARMSTM.DLL
-pSTM32F103ZC
-pSTM32F103ZD

Code -   
RO-data -    (Read Only Data)
RW-data -  (Read Write Data)
ZI-data -  (Zero-Initialized Data)
*/

#include <stm32f10x.h>

#include "gpio.h"
#include "main.h"
#include "commonfile.h"
#include "flash.h"
#include "one_wire_stm.h"
#include "fan.h"
#include "lph.h"
#include "lcd_f.h"
#include "str.h"
#include "timers.h"
#include "adc.h"
#include "pwm.h"

//#define TEST_PIN		D,7,H
//#define	TEST_PIN_SIGN	{DRIVER(TEST_PIN,OUT);on(TEST_PIN);off(TEST_PIN);}

Setting S;

uint32_t EnablePOWER;
uint32_t RegulatorCV;
uint32_t SettingsItem;
uint32_t Uout, Iout, Ujob, Ijob, DacU, DacI, AdcU, AdcI, AdcUsrU, AdcUsrI, IAdcProtect=0x0FFF;
uint32_t FanPower;// 0==auto; !0 - manual value
uint32_t TmpParam[2];
uint32_t HoldDacU;//     ,   Ujob.   U ,   .     

uint32_t TimeAlarmLongPowerOff;//,       (     )
#define TIME_LONG_POWER_OFF	(10*60*1000)//10  

//------
uint32_t Freg;
uint32_t FregPulseWidth;//        	
float StepDacPila, DacPila;
uint8_t GeneratorMode, TreugolnikDir;
#define GEN_PRIAMUG	1
#define GEN_PILA	2
#define GEN_TREUG	3
#define GEN_DSPLUS	4
//---------------

uint8_t ModeUI, AppState;
int32_t TimeModeEnableRegulator;
#define TIME_ENABLE_REGULATOR	10000
uint16_t Key;
uint8_t LcdBuff[2][16], LcdOutput[2][16], BlankParam;
uint32_t LcdBlank[2][1];
uint32_t DisplayScreen;
uint32_t Preset;
uint8_t strelka;
uint8_t TAlarm=0;
uint32_t TrigerCurentProtection;//unsigned char 
uint32_t EncoderSpeed, PeriodRotate;
uint8_t RotateEnc;
#define ROTATE_LEFT		1
#define ROTATE_RIGHT	2

#define TIM_SHOW_PARAM	700
#define TIM_BLANK_PARAM	300

//#define USR_ADC_DATA	201
//#define ADC_OVR			_BV(4)
#define ADC_OVR			_BV(4)
#define USR_ADC_DATA	16*ADC_OVR

#define TIME_RESET_DISPLAY	(int32_t)(30*1000)

//volatile uint8_t Test;//***********************************!

#define SETTING_NUM	9 //!- ,  == ST_SETTINGS_ITEM_EXIT
enum AppST{ST_WORK, ST_SETTINGS, 
ST_SETTINGS_ITEM, ST_SETTINGS_ITEM_1, ST_SETTINGS_ITEM_2, ST_SETTINGS_ITEM_3, 
ST_SETTINGS_ITEM_4, ST_SETTINGS_ITEM_5, ST_SETTINGS_ITEM_6, ST_SETTINGS_ITEM_7, ST_SETTINGS_ITEM_8, ST_SETTINGS_ITEM_EXIT, //   .  ! 
ST_PRESET_1,
ST_CURRENT_PROTECT,
ST_FAN_1, ST_FAN_2,
ST_TEMPER_1, 
ST_CALIBROVKA_U1, ST_CALIBROVKA_U2, ST_CALIBROVKA_U3,
ST_CALIBROVKA_I1, ST_CALIBROVKA_I2, ST_CALIBROVKA_I3, 
ST_RESET_SETTINGS, 
ST_GENERATOR, ST_GENERATOR_1, ST_GENERATOR_2, ST_GENERATOR_3, ST_GENERATOR_4,
ST_DATA_CRC_ERROR,
ST_ALARM_T
};
enum SettingOrder{SO_PRESET, SO_CURRENT_PROT, SO_FAN, SO_TEMPER, SO_CALIBR_U, SO_CALIBR_I, SO_GENERATOR, SO_RESET, SO_EXIT};


void ADC1_IRQHandler(void){//ADC1_IRQHandler-   startup_stm32f10x_ld_vl.s
	//if (ModeUI==MODE_WORK)
		{
		DAC_U_REGISTR=0;//  DAC
		DAC_I_REGISTR=0;
		EnablePOWER=0;
		RegulatorCV=0; 
		on(LED_MODE_I);
		}
	ADC1->CR1&=~ADC_CR1_AWDIE;//     
	ADC1->SR&=~ADC_SR_AWD;	//   
}

void TIM1_UP_TIM16_IRQHandler(void){
uint32_t DacTmp=0;
	TIM1->SR&=~TIM_SR_UIF;//Update interrupt Flag 
	
	
	switch (GeneratorMode)
	{
	case GEN_PRIAMUG:{
		DacTmp=DacU;
		}
		break;
	case GEN_PILA:{
		if (DacPila<DacU+StepDacPila){
			DacPila+=StepDacPila;
			}
			else{
			DacPila=0;
			}
		}
		DacTmp=(uint32_t)DacPila;
		break;
	case GEN_TREUG:{
		if (TreugolnikDir==0){
			if (DacPila<DacU+StepDacPila){
				DacPila+=StepDacPila;
				}
				else{
				TreugolnikDir=1;
				}
			}
		else{
			if (DacPila>StepDacPila){
				DacPila-=StepDacPila;
				}
				else{
				TreugolnikDir=0;
				}
			}
		DacTmp=(uint32_t)DacPila;
		}
		break;
	}
	
	if (EnablePOWER) DAC_U_REGISTR=DacTmp;
}

void TIM1_CC_IRQHandler(void){
	if (GeneratorMode==GEN_PRIAMUG)	DAC_U_REGISTR=0;
	TIM1->SR&=~TIM_SR_CC1IF;//Capture/Compare 1 interrupt Flag
}
/*
static void clock_init(void){
	RCC->CR |= RCC_CR_HSION;
	while((RCC->CR & RCC_CR_HSIRDY) == 0);

	SCB->VTOR = FLASH_BASE; // Vector Table Relocation in Internal FLASH. 
}
*/
static void peripheral_clock_enable(void){
	RCC->APB2ENR|=RCC_APB2ENR_IOPAEN;
	RCC->APB2ENR|=RCC_APB2ENR_IOPBEN;
	RCC->APB2ENR|=RCC_APB2ENR_IOPCEN;
	
	RCC->APB2ENR|=RCC_APB2ENR_AFIOEN;//Alternate Function I/O clock enable
	AFIO->MAPR|=AFIO_MAPR_SWJ_CFG_1;//010: JTAG-DP Disabled and SW-DP Enabled
	
	//---Timers-------
	RCC->APB2ENR|=RCC_APB2ENR_TIM17EN;// 
	RCC->APB1ENR|=RCC_APB1ENR_TIM3EN;
	//RCC->APB1ENR|=RCC_APB1ENR_TIM2EN;//  . init pwm

}

void port_init(void){
	peripheral_clock_enable();
	
	pmode(LED_MODE_U, PIN_CFG_OPP_2MHZ);
	pmode(LED_MODE_I, PIN_CFG_OPP_2MHZ);
	pmode(LED_POWER, PIN_CFG_OPP_2MHZ);
	
	pmode(BTN_POWER, PIN_CFG_IP);//  
	pmode(BTN_ENTER, PIN_CFG_IP);// 
	pmode(BTN_ENCODER, PIN_CFG_IP);// 
	
	off(BTN_POWER);//  
	off(BTN_ENTER);
	off(BTN_ENCODER);
	
	pmode(T3_CH1, PIN_CFG_IP);
	pmode(T3_CH2, PIN_CFG_IP);
	on(T3_CH1);//  
	on(T3_CH2);
	
	pmode(PWM_FAN, PIN_CFG_APP_2MHZ);//	on(PWM_FAN);

	//pmode(PWM_BGLED, PIN_CFG_APP_2MHZ);
	pmode(PWM_BGLED, PIN_CFG_OPP_2MHZ); on(PWM_BGLED);
	
	// ADC
	pmode(ADC_PIN_U, PIN_CFG_AI);				//    ,       !
	pmode(ADC_PIN_I, PIN_CFG_AI);				//    ,       !
	//DAC
	pmode(DAC_PIN_U,PIN_CFG_AI);//     
	pmode(DAC_PIN_I,PIN_CFG_AI);//     
	
	
}



void systemtick_init(void){
//    core_cm3.h   "CD00228163 Cortex-M3 programming manual.pdf"
//  4.5 SysTick timer (STK)  . . . . . . . . . . . . .  149
	SysTick->LOAD=1000-1;
	SysTick->CTRL=SysTick_CTRL_ENABLE;// AHB/8
	// 24meg 1ms
	//SysTick->CTRL|=SysTick_CTRL_CLKSOURCE;//     Processor clock (AHB)
}

void skan_key(void){
static uint32_t AntiDrbPower, AntiDrbEnkoder, AntiDrbEnter;
static int16_t OldTCNT;
int16_t Tcnt;

//Button Power
	Key &= ~ KEY_POWER_UP;
	if (signal(BTN_POWER)){
		AntiDrbPower++;
		if (AntiDrbPower == KEY_SHORT_TIME) {
			Key|=KEY_POWER;
			}
		if (AntiDrbPower == KEY_LONG_TIME) {
			Key|=KEY_POWER_LONG;
			}
		} 
	else{
		if (AntiDrbPower > 5) AntiDrbPower=5;
		if (AntiDrbPower) AntiDrbPower--;
		if (AntiDrbPower==0) {
			if (Key&KEY_POWER) Key|=KEY_POWER_UP;
			Key&=~(KEY_POWER|KEY_POWER_LONG);
			}
		}
		
//Button Encoder	
	Key &= ~ KEY_ENKODER_UP;
	if (signal(BTN_ENCODER)){
		AntiDrbEnkoder++;
		if (AntiDrbEnkoder == KEY_SHORT_TIME) {
			Key|=KEY_ENKODER;
			}
		if (AntiDrbEnkoder == KEY_LONG_TIME) {
			Key|=KEY_ENKODER_LONG;
			}
		} 
	else{
		if (AntiDrbEnkoder > 5) AntiDrbEnkoder=5;
		if (AntiDrbEnkoder) AntiDrbEnkoder--;
		if (AntiDrbEnkoder==0) {
			if (Key&KEY_ENKODER) Key|=KEY_ENKODER_UP;
			Key &= ~ (KEY_ENKODER|KEY_ENKODER_LONG);
			}
		}
		
//Menu / Enter
	Key &= ~ KEY_ENTER_UP;
	if (signal(BTN_ENTER)){
		AntiDrbEnter++;
		if (AntiDrbEnter == KEY_SHORT_TIME) {
			Key|=KEY_ENTER;
			}
		if (AntiDrbEnter == KEY_LONG_TIME) {
			Key|=KEY_ENTER_LONG;
			}
		} 
	else{
		if (AntiDrbEnter > 5) AntiDrbEnter=5;
		if (AntiDrbEnter) AntiDrbEnter--;
		if (AntiDrbEnter==0) {
			if (Key&KEY_ENTER) Key|=KEY_ENTER_UP;
			Key &= ~ (KEY_ENTER|KEY_ENTER_LONG);
			}
		}
		
//Rotate encoder	
	Key &= ~KEY_ROTATE_ENC;
	RotateEnc=0;
	
	//Tcnt=(int16_t)TIM3->CNT / 4;	
	Tcnt=(int16_t)TIM3->CNT / 2;
	if ( Tcnt > OldTCNT ) RotateEnc=ROTATE_RIGHT;//    ,     , . . 
	if ( Tcnt < OldTCNT ) RotateEnc=ROTATE_LEFT;//     2
	OldTCNT=Tcnt;
		
	PeriodRotate++;
	EncoderSpeed=1;
	if (RotateEnc){
		Key|=KEY_ROTATE_ENC|KEY_DISABLE_BLANK;
		if (PeriodRotate < 50) EncoderSpeed=10; //   , =1
		if (PeriodRotate < 24) EncoderSpeed=50; 
		if (PeriodRotate <= 5) EncoderSpeed=100;
		//if (PeriodRotate < 75) EncoderSpeed=10; //   , =1
		//if (PeriodRotate < 32) EncoderSpeed=50; 
		//if (PeriodRotate < 5) EncoderSpeed=100;
//TTT=EncoderSpeed;
		PeriodRotate=0;
		}
}

void reset_settings(void){
uint8_t *p;
uint32_t j;
	p=(uint8_t *)&S;
	for (j=0; j<sizeof(S); j++){
		p[j]=0;
		}	
	S.Preset[0][0]=420;
	S.Preset[0][1]=1000;
	S.Preset[1][0]=330;
	S.Preset[1][1]=500;
	S.Preset[2][0]=500;
	S.Preset[2][1]=500;
	S.Preset[3][0]=900;
	S.Preset[3][1]=500;
	S.Preset[4][0]=1200;
	S.Preset[4][1]=500;
	S.Preset[5][0]=1800;
	S.Preset[5][1]=500;
	S.Preset[6][0]=2400;
	S.Preset[6][1]=500;
	S.TemperEvent[0]=450;
	S.TemperEvent[1]=450;
	S.Fan.TLow=280;
	S.Fan.THi=370;
	//S.Fan.ULow=0;
	S.Fan.UHi=500;
	
	
}

void lcd_repaint(void){
uint8_t j;
uint32_t b=1;

	for(j=0; j<16; j++){
		LcdOutput[0][j]=LcdBuff[0][j];
		LcdOutput[1][j]=LcdBuff[1][j];
		if (BlankParam){
			if ( LcdBlank[0][0] & b ) 	LcdOutput[0][j]=' ';
			if ( LcdBlank[1][0] & b )	LcdOutput[1][j]=' ';
			} 
		b<<=1;
		}
	lcd_puts_yx(&LcdOutput[0][0],16,0,0);
	lcd_puts_yx(&LcdOutput[1][0],16,0,1);
}

void clear_lcdbuff(void){
uint8_t i, *p;
	p=&LcdBuff[0][0];
	for(i=0; i<sizeof(LcdBuff); i++) p[i]=' ';//*(p++)=' ';
}

static void copy_in_lcdbuff(const uint8_t *s, uint8_t y){
	uint8_t j;
	for(j=0; j<16; j++){
		LcdBuff[y][j]=s[j];
		}
}

void load_user_simvol(uint8_t adress, const uint8_t *str )
{
 uint8_t i;
	lcd_instructions_set(adress|SET_CGRAM_ADDRESS);
	for(i=0; i<8; i++){
		lcd_write_data(str[i]);
		}
}


void str_ui(uint16_t Adc, uint8_t strI, uint8_t x){//
uint32_t Buf[BCD_SIZEOF];
	itoa2(Adc,Buf);
	LcdBuff[strI][x]=Buf[3];//Buf[0];
	if ( strI )   LcdBuff[strI][x+1]='.'; else LcdBuff[strI][x+1]=Buf[2];//Buf[1]
	if ( !strI )  LcdBuff[strI][x+2]='.'; else LcdBuff[strI][x+2]=Buf[2];//Buf[1]
	LcdBuff[strI][x+3]=Buf[1];//Buf[2];
	LcdBuff[strI][x+4]=Buf[0];//Buf[3];
	if (x <= 10){// 16 ,      
		if ( strI ) LcdBuff[strI][x+5]='A'; else LcdBuff[strI][x+5]='B';
		}
		
	
}

void itoa_4digit_in_lcdbuf(uint32_t Data, uint8_t y, uint8_t x){
uint32_t s[BCD_SIZEOF];
	itoa2(Data,s);
	LcdBuff[y][x]=s[3];
	LcdBuff[y][x+1]=s[2];
	LcdBuff[y][x+2]=s[1];
	LcdBuff[y][x+3]=s[0];
}

void display0(uint32_t Preset){//WORK
//05.03B   >05.04
//0.005A    1.000
uint32_t U,I;
float r; 
//U=S.UkoefA*ADC+S.UkoefB

	r=S.UkoefA*(float)AdcU+S.UkoefB;
//	uout_tmp=r*100;
//	uout_tmp+=49;
	r+=0.5;
	Uout=r;
					
	//Uout=S.UkoefA*(float)AdcU+S.UkoefB+0.45;
	
	r=S.IkoefA*(float)AdcI+S.IkoefB;
	r+=0.5;
	Iout=r;
	//Iout=S.IkoefA*(float)AdcI+S.IkoefB+0.45;

	clear_lcdbuff();

	if (Preset==0){
		U=Ujob;
		I=Ijob;
		}
		else{
		U=S.Preset[Preset-1][0];
		I=S.Preset[Preset-1][1];
		LcdBuff[0][7]='P';
		LcdBuff[0][8]='r';
		LcdBuff[0][9]='e';
		LcdBuff[1][7]='S';
		LcdBuff[1][8]='e';
		LcdBuff[1][9]='t';
		}

	str_ui(Uout,0,0);
	str_ui(U,0,11);
	
	str_ui(Iout,1,0);
	str_ui(I,1,11);
	
	if (TrigerCurentProtection)	LcdBuff[1][9]='t'; 
	if (HoldDacU)	{
		LcdBuff[0][5]=' '; 
		LcdBuff[0][6]='H'; 
		LcdBuff[0][7]='o'; 
		LcdBuff[0][8]='l'; 
		LcdBuff[0][9]='d'; 
		}
	
/*/---------------------
itoa2(TTT,Buf);
	LcdBuff[0][7]=Buf[2];
	LcdBuff[0][8]=Buf[1];
	LcdBuff[0][9]=Buf[0];	
//---------------------*/
}

void display1(void){//WORK
//12.00B P42` T42`
//0123456789012345
//1.324A 2.000 10W
uint32_t PofVT=0;
uint32_t s[BCD_SIZEOF],n=1;
float r; 

	r=S.UkoefA*(float)AdcU+S.UkoefB;
	r+=0.5;
	Uout=r;
	//Uout=S.UkoefA*(float)AdcU+S.UkoefB+0.45;
	
	r=S.IkoefA*(float)AdcI+S.IkoefB;
	r+=0.5;
	Iout=r;
	//Iout=S.IkoefA*(float)AdcI+S.IkoefB+0.45;

	clear_lcdbuff();
	str_ui(Uout,0,0);
	str_ui(Iout,1,0);
	
	if (RegulatorCV==1){//1.324A 2.000 10W	
		str_ui(Ijob,1,7);
		n=0;
		}
		else
		str_ui(Ujob,0,7);
		
	LcdBuff[RegulatorCV][6]=' ';//'(';	
	LcdBuff[RegulatorCV][12]=' ';	
	//LcdBuff[RegulatorCV][12]=' ';	

	PofVT=(uint32_t)Uout*Iout;
	PofVT/=1000;	
	PofVT+=45;	//  
	itoa2(PofVT,s);
	LcdBuff[RegulatorCV][13]=s[3];	
	LcdBuff[RegulatorCV][14]=s[2];	
	LcdBuff[RegulatorCV][15]='W';	
	
	itoa2(Temperaturs[T_VT],s);
	LcdBuff[n][7]='P';	
	LcdBuff[n][8]=s[2];	
	LcdBuff[n][9]=s[1];	
	if (s[0]>'5') LcdBuff[n][10]=1; else LcdBuff[n][10]=0;
	itoa2(Temperaturs[T_TRANS],s);
	LcdBuff[n][12]='T';	
	LcdBuff[n][13]=s[2];//1	
	LcdBuff[n][14]=s[1];//2	
	//LcdBuff[n][15]=0;	
	if (s[0]>'5') LcdBuff[n][15]=1; else LcdBuff[n][15]=0;
}



void display_settings(void){
	clear_lcdbuff();
	copy_in_lcdbuff((uint8_t *)str_settings, 0);
}

void display_settings_item(void){//  
uint8_t s1;
	if (RotateEnc==ROTATE_LEFT) {
		if (SettingsItem) SettingsItem--;
		if (SettingsItem<SETTING_NUM-1) strelka=0; else strelka=1;
		}
	if (RotateEnc==ROTATE_RIGHT) {
		if (++SettingsItem>=SETTING_NUM) SettingsItem=SETTING_NUM-1;
		if (SettingsItem>0) strelka=1; else strelka=0;
		}

	s1=SettingsItem;	
	if (strelka>0)	
		if (s1>0) s1--;	
	
	copy_in_lcdbuff((uint8_t *)&str_SettingsItem[s1][0], 0);
	copy_in_lcdbuff((uint8_t *)&str_SettingsItem[s1+1][0], 1);
	
	LcdBuff[strelka][1]='>';
}

void display_fan_1(void){
uint32_t s[BCD_SIZEOF];
	clear_lcdbuff();
	LcdBuff[0][0]='T';
	LcdBuff[0][1]=0;
	LcdBuff[0][2]='C';
	LcdBuff[0][5]='L';
	itoa2(TmpParam[0],s);//itoa2(S.Fan.TLow,s);
	LcdBuff[0][6]=s[1];//2
	LcdBuff[0][7]=s[0];//3
	LcdBuff[0][8]=0;
	itoa2(TmpParam[1],s);//itoa2(S.Fan.THi,s);
	LcdBuff[0][11]='H';
	LcdBuff[0][12]=s[1];
	LcdBuff[0][13]=s[0];
	LcdBuff[0][14]=0;
	
	LcdBuff[1][0]='P';
	LcdBuff[1][1]='W';
	LcdBuff[1][2]='M';
	LcdBuff[1][5]='L';
	itoa2(S.Fan.ULow,s);
	LcdBuff[1][6]=s[2];
	LcdBuff[1][7]=s[1];
	LcdBuff[1][8]=s[0];
	LcdBuff[1][11]='H';
	itoa2(S.Fan.UHi,s);
	LcdBuff[1][12]=s[2];
	LcdBuff[1][13]=s[1];
	LcdBuff[1][14]=s[0];
}

void display_fan_2(void){
uint32_t s[BCD_SIZEOF];
	clear_lcdbuff();
//const uint8_t str_FanRaskr[17]={80,97,99,186,112,121,191,186,32,80,87,77,32,48,48,48,'\0'}; // PWM 000
	LcdBuff[0][0]='P';
	LcdBuff[0][1]='a';
	LcdBuff[0][2]='c';
	LcdBuff[0][3]=186;//
	LcdBuff[0][4]=112;//
	LcdBuff[0][5]='y';
	LcdBuff[0][6]=191;//
	LcdBuff[0][7]=186;//
	
	LcdBuff[0][9]='P';
	LcdBuff[0][10]='W';
	LcdBuff[0][11]='M';
	
	itoa2(S.Fan.USpinUp,s);
	LcdBuff[0][13]=s[2];
	LcdBuff[0][14]=s[1];
	LcdBuff[0][15]=s[0];
	
	LcdBuff[1][0]='B';
	LcdBuff[1][1]='p';//
	LcdBuff[1][2]='e';//
	LcdBuff[1][3]=188;//
	LcdBuff[1][4]=199;//
	LcdBuff[1][5]='-';//
	
	itoa2(S.Fan.TimSpinUp,s);
	LcdBuff[1][6]=s[1];
	LcdBuff[1][7]=s[0];
	
	LcdBuff[1][9]= 'T';
	LcdBuff[1][10]='<';
	LcdBuff[1][11]='L';
	LcdBuff[1][12]='-';
	if (S.Fan.OffTLo==0){// 
		LcdBuff[1][13]='B';//179;//
		LcdBuff[1][14]=186;//
		LcdBuff[1][15]=187;//
		}else{
		LcdBuff[1][13]='O';//
		LcdBuff[1][14]=191;//
		LcdBuff[1][15]=186;//
		}
}

void edit_param(uint32_t *p, uint32_t inc, uint32_t limit){
uint32_t t;
static uint32_t oldInc;
	if (RotateEnc==ROTATE_LEFT) {
		if (*p>inc) *p-=inc; else *p=0;
		}
	if (RotateEnc==ROTATE_RIGHT) {
		if ( *p < (limit+1-inc) ) *p+=inc; else *p=limit;
		}
	if (RotateEnc){
		if (oldInc != inc)
			if (*p < (limit+1-inc) )	
			{
			oldInc = inc;
			t=(*p)/10;
			*p=t*10;
			}
		}else oldInc = inc;
}


uint8_t generator_key(uint8_t limit){
	LcdBlank[0][0]=0;
	LcdBlank[1][0]=0;
			
	if (SettingsItem==0){
		LcdBlank[0][0]=_BV(1)|_BV(2)|_BV(3)|_BV(4)|_BV(5);
		if ( Key & (KEY_ENKODER|KEY_ENTER) ){
			SettingsItem=0;
			Preset=0;
			GeneratorMode=0;
			EnablePOWER=0;
			Key=0;
			NVIC_DisableIRQ(TIM1_UP_TIM16_IRQn);// 
			NVIC_DisableIRQ(TIM1_CC_IRQn);
			tim1_off();
			AppState=ST_GENERATOR;
			
			DAC->CR&=~(DAC_CR_WAVE1|DAC_CR_MAMP1|DAC_CR_TEN1);
			tim_dac1_off();
			return 1;
			}
		}
				
	if (Preset==0){
		edit_param(&SettingsItem,1,limit);
		if ( Key & (KEY_ENKODER|KEY_ENTER) ) {
			Preset=1;
			Key=0;
			}
		}
	
	if (Key & KEY_POWER_UP){
		if (EnablePOWER) EnablePOWER=0;//command power on=1;//command power off
		else EnablePOWER=1;//command power on
		Key=0;
		}
	
	clear_lcdbuff();
	str_ui(Ujob,0,10);
	LcdBuff[0][1]='H';
	LcdBuff[0][2]='a';
	LcdBuff[0][3]=183;//
	LcdBuff[0][4]='a';
	LcdBuff[0][5]=227;//
	
	LcdBuff[0][9]='U';
	return 0;
}
void reg_u_job(void){
uint32_t DacTmp=0, JobTmp=0;
	JobTmp=Ujob;
	edit_param(&Ujob,EncoderSpeed,3000);
	DacTmp=DacU;
	DacU=((float)Ujob-S.UDackoefB)/S.UDackoefA;
	if (DacU>4095) {
		DacU=DacTmp;
		Ujob=JobTmp;
		}
}

void reset_hold_dac_u(void){
	if ( HoldDacU ){
		HoldDacU=0;
		Ujob=TmpParam[0];
		DacU=((float)Ujob-S.UDackoefB)/S.UDackoefA;
		}
}



uint8_t key_action_exit_state(uint32_t Count, uint32_t ExitState, uint32_t Item){
// 0 ; 1 -       ; 2 -       set
//Count -  , ExitState -      , Item -          
//SettingsItem -         [SettingsItem] 
#define MENU_UP_BTNPOWER	1
#define MENU_NEXT_BTNSET	2
	LcdBlank[0][0]=0;
	LcdBlank[1][0]=0;
	if ( Key & (KEY_ENKODER|KEY_ENTER) ){
		Key=0;
		if (++SettingsItem>=Count) {
			SettingsItem=Item;
			AppState=ExitState;
			return MENU_NEXT_BTNSET;
			}
		}
	if (Key & KEY_POWER_UP){
		SettingsItem=Item;
		AppState=ST_SETTINGS_ITEM;
		Key=0;
		return MENU_UP_BTNPOWER;
		}
	return 0;
}

void key_action(void){
uint32_t s[BCD_SIZEOF], DacTmp=0, JobTmp=0;// MeanValueDac=0,

	switch (AppState)
		{   case ST_WORK:{
				//----------switching display screen--------------------
				if (DisplayScreen==0) display0(Preset); else display1();
				//----------------------power off-----------------------
				if (EnablePOWER) {
					if ((Key & KEY_POWER)|| ((Key & KEY_ENKODER) && (ModeUI!=MODE_CHANGE_U)) ) {//Command power off
						Key&=~(KEY_POWER|KEY_POWER_LONG|KEY_POWER_UP);
						off(LED_MODE_I); off(LED_MODE_U);
						EnablePOWER=0;
						}
					Preset=0;
					}
				else{
					if (Key & KEY_POWER_UP) {
						EnablePOWER=1;//command power on
						if (TrigerCurentProtection) {
							ADC1->CR1|=ADC_CR1_AWDIE;//    ( )
							//DAC->CR &= ~DAC_CR_TEN1;//DAC channel1 Trigger disable
							}
							//else
							//DAC->CR |= DAC_CR_TEN1;//DAC channel1 Trigger enable
						}
					}
				//****************enter in settings********************
				if (ModeUI==MODE_WORK) {
					if ( Key & KEY_ENTER_LONG ) {// enter in settings
						AppState=ST_SETTINGS;
						display_settings();
						break;
						}
					if (EnablePOWER)//      U  I    
						edit_param(&DisplayScreen,1,1);
						else
						edit_param(&Preset,1,PRESET_COUNT);
					if (Preset){
						DisplayScreen=0;
						if ((Key & KEY_ENKODER)||( Key & KEY_ENTER_UP )){
							Ujob=S.Preset[Preset-1][0];
							Ijob=S.Preset[Preset-1][1];
							DacU=((float)Ujob-S.UDackoefB)/S.UDackoefA;
							DacI=((float)Ijob-S.IDackoefB)/S.IDackoefA;
							Preset=0;
							Key=0;
							}
						}
					}
				//**************change mode adjust U or I**************	
				if ( Key & KEY_ENTER_UP ){ // change mode adjust U or I 
					if (++ModeUI>MODE_CHANGE_I) {ModeUI=MODE_WORK; off(LED_MODE_I); off(LED_MODE_U);}
					reset_hold_dac_u();
					TimeModeEnableRegulator=TIME_ENABLE_REGULATOR;
					DisplayScreen=0;//  U  I    0
					Preset=0;
					}
				if (ModeUI==MODE_CHANGE_U) {//adjust U enable
						JobTmp=Ujob;
						edit_param(&Ujob,EncoderSpeed,3000);
						
						if ( (Key & KEY_ENKODER_UP)  && EnablePOWER ){
							if (HoldDacU==0) {
								HoldDacU=1;
								TmpParam[0]=Ujob;
								}
								else 
								HoldDacU=0;
							}
						
						if (HoldDacU==0)
						{
						DacTmp=DacU;
						DacU=((float)Ujob-S.UDackoefB)/S.UDackoefA;
						if (DacU>4095) {
							DacU=DacTmp; 
							Ujob=JobTmp;
							} 
						}
						
						LcdBuff[0][10]='>';
						on(LED_MODE_U);
						off(LED_MODE_I);
						}
						else	
					if (ModeUI==MODE_CHANGE_I) {//adjust i enable
						JobTmp=Ijob;
						edit_param(&Ijob,EncoderSpeed,3000);
						IAdcProtect=((float)Ijob-S.IkoefB)/S.IkoefA;//Iout=S.IkoefA*(float)AdcI+S.IkoefB;
						ADC1->HTR=IAdcProtect/ADC_OVR-5;
						
						DacTmp=DacI;
						DacI=((float)Ijob-S.IDackoefB)/S.IDackoefA;
						if (DacI>4095) {
							DacI=DacTmp;
							Ijob=JobTmp;
							}
						
						LcdBuff[1][10]='>';
						on(LED_MODE_I);
						off(LED_MODE_U);
						}
				}
				break;
				
			case ST_SETTINGS:{
		        if (Key & KEY_ENTER_UP){
					strelka=0;
					SettingsItem=0;
					AppState=ST_SETTINGS_ITEM;
					}
				}
				break;
				
			case ST_SETTINGS_ITEM:{
				display_settings_item();
				Preset=0;
				if (Key & (KEY_ENKODER_UP|KEY_ENTER)){
					AppState=ST_SETTINGS_ITEM+SettingsItem+1;
					SettingsItem=0;
					Key=0;
					}
				if (Key & KEY_POWER_UP){
					//AppState=ST_SETTINGS_ITEM_EXIT;//exit
					//SettingsItem=1;
					//Key=0;
					AppState=ST_WORK;//exit
					SettingsItem=0;
					Key=0;
					
					}
				}
				break;
				
			//*************************************************************************
			case ST_SETTINGS_ITEM_1:{//1 PRESET
				AppState=ST_PRESET_1;
				}
				break;	
			case ST_SETTINGS_ITEM_2:{//2   
				AppState=ST_CURRENT_PROTECT;
				}
				break;	
			case ST_SETTINGS_ITEM_3:{//3 Fan
				TmpParam[0]=S.Fan.TLow/10;
				TmpParam[1]=S.Fan.THi/10;
				AppState=ST_FAN_1;
				}
				break;	
			case ST_SETTINGS_ITEM_4:{//4 
				TmpParam[0]=S.TemperEvent[0]/10;
				TmpParam[1]=S.TemperEvent[1]/10;
				AppState=ST_TEMPER_1;
				}
				break;
			case ST_SETTINGS_ITEM_5:{//5  U
				TmpParam[0]=S.USetPoint[0]/10;
				TmpParam[1]=S.USetPoint[1]/100;
				//S.USetPoint[0]/=10;
				//S.USetPoint[1]/=100;
				AppState=ST_CALIBROVKA_U1;
				}
				break;	
			case ST_SETTINGS_ITEM_6:{//6  I
				//S.ISetPoint[1]/=100;
				TmpParam[0]=S.ISetPoint[0];
				TmpParam[1]=S.ISetPoint[1]/100;
				AppState=ST_CALIBROVKA_I1;
				}
				break;
			case ST_SETTINGS_ITEM_7:{//7  NiCd 
				AppState=ST_GENERATOR;
				}
				break;
			case ST_SETTINGS_ITEM_8:{////8  
				AppState=ST_RESET_SETTINGS;
				}
				break;	
		//*************************************************************************
		//--EXIT----------------------------------------
			case ST_SETTINGS_ITEM_EXIT:{// 7 Exit
				//AppState=ST_WORK;// Exit
				//break;
				LcdBlank[0][0]=0;
				LcdBlank[1][0]=0;
				
				if ( Key & (KEY_ENKODER|KEY_ENTER) ){
					Key=0;
					if (SettingsItem==0){
						//eeprom_save();
						flash_struct_save((uint32_t *)&S, (uint8_t *)&S, sizeof(S));
						
						}
					SettingsItem=0;
					AppState=ST_WORK;
					break;
					}
					
				copy_in_lcdbuff((uint8_t *)str_Store, 0);
				copy_in_lcdbuff((uint8_t *)str_StoreEsOrNo, 1);
				edit_param(&SettingsItem,1,1);
				if (SettingsItem==0) LcdBlank[1][0]=_BV(3)|_BV(4)|_BV(5); else LcdBlank[1][0]=_BV(8)|_BV(9)|_BV(10)|_BV(11);
				}
				break;	
		//--FAN----------------------------------------------
			case ST_FAN_1:{//3 Fan
				Preset=key_action_exit_state(4, ST_FAN_2, SO_FAN);
				if ( Preset ){
					if ( Preset==MENU_NEXT_BTNSET ){
						SettingsItem=0;
						S.Fan.TLow=TmpParam[0]*10;
						S.Fan.THi=TmpParam[1]*10;
						calculation_step_U();
						}
					FanPower=0;
					break;
					}
				
				if (SettingsItem==0) {LcdBlank[0][0]=_BV(6)|_BV(7)|_BV(8);		edit_param(&TmpParam[0],1,90);}//edit_param(&S.Fan.TLow,1,90);
				if (SettingsItem==1) {LcdBlank[0][0]=_BV(12)|_BV(13)|_BV(14);	edit_param(&TmpParam[1],1,90);}//edit_param(&S.Fan.THi,1,90);
				if (SettingsItem==2) {LcdBlank[1][0]=_BV(6)|_BV(7)|_BV(8);		edit_param(&S.Fan.ULow,EncoderSpeed, PWM_FAN_MAX_VALUE);	 PWM_FAN_VALUE=FanPower=S.Fan.ULow;}
				if (SettingsItem==3) {LcdBlank[1][0]=_BV(12)|_BV(13)|_BV(14);	edit_param(&S.Fan.UHi,EncoderSpeed, PWM_FAN_MAX_VALUE);	 PWM_FAN_VALUE=FanPower=S.Fan.UHi;}
				
				//calculation_step_U();
				display_fan_1();
				}
				break;	
				
			case ST_FAN_2:{//2 Fan 
				if ( key_action_exit_state(3, ST_SETTINGS_ITEM, SO_FAN) ) {FanPower=0; break;}
	
				if (SettingsItem==0) {LcdBlank[0][0]=_BV(13)|_BV(14)|_BV(15); edit_param(&S.Fan.USpinUp,EncoderSpeed, PWM_FAN_MAX_VALUE);   PWM_FAN_VALUE=FanPower=S.Fan.USpinUp;}
				if (SettingsItem==1) {LcdBlank[1][0]=_BV(6)|_BV(7); 			edit_param(&S.Fan.TimSpinUp,1,90); FanPower=0;}
				if (SettingsItem==2) {LcdBlank[1][0]=_BV(13)|_BV(14)|_BV(15);	edit_param(&S.Fan.OffTLo,1,1);}

				display_fan_2();
				}
				break;
		//--TEMPERATURE---------------------------------------------
			case ST_TEMPER_1:{//4 Temperature				
			if ( key_action_exit_state(2, ST_SETTINGS_ITEM, SO_TEMPER) == MENU_NEXT_BTNSET ){//   4-1
					S.TemperEvent[0]=TmpParam[0]*10;
					S.TemperEvent[1]=TmpParam[1]*10;
					break;
					}
				copy_in_lcdbuff((uint8_t *)str_MaxTtrans, 0);
				copy_in_lcdbuff((uint8_t *)str_MaxTRadiator, 1);	
				
				LcdBuff[SettingsItem][0]='>';
				LcdBlank[SettingsItem][0]=_BV(12)|_BV(13); 
				edit_param(&TmpParam[SettingsItem],1,99);
				
				itoa2(TmpParam[0],s);
				LcdBuff[0][12]=s[1];
				LcdBuff[0][13]=s[0];
				itoa2(TmpParam[1],s);
				LcdBuff[1][12]=s[1];
				LcdBuff[1][13]=s[0];
				}
				break;
		//--VOLTAGE--------------------------------
			case ST_CALIBROVKA_U1:{//5   SET POINTS
				//  
				Preset=key_action_exit_state(2, ST_CALIBROVKA_U2, SO_CALIBR_U);//   5-1		
				if ( Preset ){
					if ( Preset==MENU_NEXT_BTNSET ){
						SettingsItem=0;
						S.USetPoint[0]=TmpParam[0]*10;
						S.USetPoint[1]=TmpParam[1]*100;
						EnablePOWER=1;
						}
					Ujob=0;	
					DacU=0;
					break;
					}
				 
				
				copy_in_lcdbuff((uint8_t *)str_Point, 0);
				copy_in_lcdbuff((uint8_t *)str_Point, 1);	
				
				LcdBuff[SettingsItem][0]='>';
				LcdBuff[1][1]='2';
				LcdBlank[SettingsItem][0]=_BV(12)|_BV(13)|_BV(14); 
				edit_param(&TmpParam[SettingsItem],1,30);//edit_param(&S.USetPoint[SettingsItem],1,30);
				
				itoa2(TmpParam[0],s);//itoa2(S.USetPoint[0],s);
				LcdBuff[0][12]=s[1];
				LcdBuff[0][13]='.';
				LcdBuff[0][14]=s[0];
				LcdBuff[0][15]='B';
				itoa2(TmpParam[1],s);//itoa2(S.USetPoint[1],s);
				LcdBuff[1][13]=s[1];
				LcdBuff[1][14]=s[0];
				LcdBuff[1][15]='B';
				}
				break;
				
			case ST_CALIBROVKA_U2:{//5  
				//       
				if ( Key & KEY_ENTER ){
					S.UAdcPoint[SettingsItem]=AdcU;
					S.UDacPoint[SettingsItem]=DacU;
					}
				
				Key &= ~KEY_ENKODER;		
				if ( key_action_exit_state(2, ST_CALIBROVKA_U3, SO_CALIBR_U) ){
					Ujob=0;
					DacU=0;
					EnablePOWER=0;	
					break;
					}
				
				copy_in_lcdbuff((uint8_t *)str_SetU, 0);
				LcdBuff[0][14]=SettingsItem+'1';
				LcdBuff[0][15]=191;//
	
				if (SettingsItem==0) {
					itoa2(S.USetPoint[0],s);
					LcdBuff[1][0]=s[2];
					LcdBuff[1][1]='.';
					LcdBuff[1][2]=s[1];
					LcdBuff[1][3]='B';
					}else{
					itoa2(S.USetPoint[1],s);
					LcdBuff[1][0]=s[3];
					LcdBuff[1][1]=s[2];
					LcdBuff[1][2]='B';
					LcdBuff[1][3]=' ';
					}
					
				LcdBuff[1][4]=' ';
				edit_param(&DacU,EncoderSpeed,4095);
				/*itoa2(DacU,s);
				LcdBuff[1][5]=s[3];
				LcdBuff[1][6]=s[2];
				LcdBuff[1][7]=s[1];
				LcdBuff[1][8]=s[0];
				LcdBuff[1][9]=' ';*/
				itoa_4digit_in_lcdbuf(DacU,1,5);
				LcdBuff[1][9]=' ';
				//AdcU=adc_rezult(ADC_U);
				/*itoa2(AdcU,s);
				LcdBuff[1][10]=s[3];
				LcdBuff[1][11]=s[2];
				LcdBuff[1][12]=s[1];
				LcdBuff[1][13]=s[0];
				LcdBuff[1][14]=' ';*/
				itoa_4digit_in_lcdbuf(AdcU/ADC_OVR,1,10);
				LcdBuff[1][14]=' ';
				
				LcdBuff[1][15]=0x7E;
				LcdBlank[1][0]=_BV(15);
				}
				break;
			case ST_CALIBROVKA_U3:{//  - 
			//a = point2-point1 / adc2-adc1
			//b = point1-a*adc1
				S.UkoefA=((float)S.USetPoint[1]-(float)S.USetPoint[0])/((float)S.UAdcPoint[1]-(float)S.UAdcPoint[0]);
				S.UkoefB=(float)S.USetPoint[0]-(float)S.UkoefA*S.UAdcPoint[0];
				//U=S.UkoefA*ADC+S.UkoefB	
			//a = point2-point1 / dac2-dac1
			//b = point1-a*dac1
				S.UDackoefA=((float)S.USetPoint[1]-(float)S.USetPoint[0]) / ((float)S.UDacPoint[1]-(float)S.UDacPoint[0]);
				S.UDackoefB=(float)S.USetPoint[0]-(float)S.UDackoefA*S.UDacPoint[0];
				//D=(Djob-S.UDackoefB)/S.UDackoefA
				
				AppState=ST_SETTINGS_ITEM;
				}
				break;
		//--CURENT--------------------------------
			case ST_CALIBROVKA_I1:{//6   SET POINTS
				Preset=key_action_exit_state(2, ST_CALIBROVKA_I2, SO_CALIBR_I);//   6-1		
				if ( Preset ){
					if ( Preset==MENU_NEXT_BTNSET ){
						SettingsItem=0;
						DacU=((float)1000-S.UDackoefB)/S.UDackoefA;//10
						S.ISetPoint[0]=TmpParam[0];
						S.ISetPoint[1]=TmpParam[1]*100;
						EnablePOWER=1;
						}
					Ijob=0;
					DacI=0;	
					break;
					}
				
				copy_in_lcdbuff((uint8_t *)str_Point, 0);
				copy_in_lcdbuff((uint8_t *)str_Point, 1);	
				
				LcdBuff[SettingsItem][0]='>';
				LcdBuff[1][1]='2';
				LcdBlank[SettingsItem][0]=_BV(12)|_BV(13)|_BV(14)|_BV(15); 
				edit_param(&TmpParam[SettingsItem],1,70);
				
				itoa2(TmpParam[0],s);
				LcdBuff[0][12]=s[1];
				LcdBuff[0][13]=s[0];
				LcdBuff[0][14]='m';
				LcdBuff[0][15]='A';
				itoa2(TmpParam[1],s);
				LcdBuff[1][12]=s[1];
				LcdBuff[1][13]='.';
				LcdBuff[1][14]=s[0];
				LcdBuff[1][15]='A';
				}
				break;
				
			case ST_CALIBROVKA_I2:{//5  			
				if ( Key & KEY_ENTER ){
					S.IAdcPoint[SettingsItem]=AdcI;
					S.IDacPoint[SettingsItem]=DacI;
					}
					
				Key &= ~KEY_ENKODER;		
				if ( key_action_exit_state(2, ST_CALIBROVKA_I3, SO_CALIBR_I) ){
					Ijob=0;
					DacI=0;
					DacU=0;
					EnablePOWER=0;	
					break;
					}
				
				copy_in_lcdbuff((uint8_t *)str_SetU, 0);
				LcdBuff[0][14]=SettingsItem+'1';
				LcdBuff[0][15]=191;//
	
				if (SettingsItem==0) {
					itoa2(S.ISetPoint[0],s);
					LcdBuff[1][0]=s[1];
					LcdBuff[1][1]=s[0];
					LcdBuff[1][2]='m';
					LcdBuff[1][3]='A';
					}else{
					itoa2(S.ISetPoint[1],s);
					LcdBuff[1][0]=s[3];
					LcdBuff[1][1]='.';
					LcdBuff[1][2]=s[2];
					LcdBuff[1][3]='A';
					}
					
				LcdBuff[1][4]=' ';
				edit_param(&DacI,EncoderSpeed,4095);
				/*itoa2(DacI,s);
				LcdBuff[1][5]=s[3];
				LcdBuff[1][6]=s[2];
				LcdBuff[1][7]=s[1];
				LcdBuff[1][8]=s[0];
				LcdBuff[1][9]=' ';*/
				itoa_4digit_in_lcdbuf(DacI,1,5);
				LcdBuff[1][9]=' ';
				
				//AdcI=adc_rezult(ADC_I);
				/*itoa2(AdcI,s);
				LcdBuff[1][10]=s[3];
				LcdBuff[1][11]=s[2];
				LcdBuff[1][12]=s[1];
				LcdBuff[1][13]=s[0];
				LcdBuff[1][14]=' ';*/
				itoa_4digit_in_lcdbuf(AdcI/ADC_OVR,1,10);
				LcdBuff[1][14]=' ';
				
				LcdBuff[1][15]=0x7E;
				LcdBlank[1][0]=_BV(15);
				}
				break;
			case ST_CALIBROVKA_I3:{//4   - 
			//a = point2-point1 / adc2-adc1
			//b = point1-a*adc1
				S.IkoefA=((float)S.ISetPoint[1]-(float)S.ISetPoint[0])/((float)S.IAdcPoint[1]-(float)S.IAdcPoint[0]);
				S.IkoefB=(float)S.ISetPoint[0]-(float)S.IkoefA*S.IAdcPoint[0];
				//I=S.IkoefA*ADC+S.IkoefB
			//a = point2-point1 / dac2-dac1
			//b = point1-a*dac1
				S.IDackoefA=((float)S.ISetPoint[1]-(float)S.ISetPoint[0]) / ((float)S.IDacPoint[1]-(float)S.IDacPoint[0]);
				S.IDackoefB=(float)S.ISetPoint[0]-(float)S.IDackoefA*S.IDacPoint[0];
				//D=(Ijob-S.IDackoefB)/S.IDackoefA
				
				AppState=ST_SETTINGS_ITEM;
				}
				break;
			//----------------------------------
			case ST_PRESET_1:{//1  
				if ( key_action_exit_state(3, ST_PRESET_1, SO_PRESET) ) break;
						
				copy_in_lcdbuff((uint8_t *)str_Preset, 0);
				if (SettingsItem==0) {edit_param(&Preset,1,PRESET_COUNT-1); LcdBlank[1][0]=_BV(0); }
				if (SettingsItem==1) {edit_param(&S.Preset[Preset][SettingsItem-1],EncoderSpeed,3000); LcdBlank[1][0]=_BV(3)|_BV(4)|_BV(5)|_BV(6)|_BV(7)|_BV(8); }
				if (SettingsItem==2) {edit_param(&S.Preset[Preset][SettingsItem-1],EncoderSpeed,5000); LcdBlank[1][0]=_BV(10)|_BV(11)|_BV(12)|_BV(13)|_BV(14)|_BV(15); }
	
				LcdBuff[1][0]=Preset+'1';
				LcdBuff[1][1]=')';
				LcdBuff[1][2]=' ';
				itoa2(S.Preset[Preset][0],s);
				LcdBuff[1][3]=s[3];
				LcdBuff[1][4]=s[2];
				LcdBuff[1][5]='.';
				LcdBuff[1][6]=s[1];
				LcdBuff[1][7]=s[0];
				LcdBuff[1][8]='B';
				LcdBuff[1][9]=' ';
				itoa2(S.Preset[Preset][1],s);
				LcdBuff[1][10]=s[3];
				LcdBuff[1][11]='.';
				LcdBuff[1][12]=s[2];
				LcdBuff[1][13]=s[1];
				LcdBuff[1][14]=s[0];
				LcdBuff[1][15]='A';
				}
				break;	
				
			//----------------------------------
			case ST_GENERATOR:{//7
				if ( key_action_exit_state(1, ST_GENERATOR_1+Preset, SO_GENERATOR) ) {
					DacU=((float)Ujob-S.UDackoefB)/S.UDackoefA;
					Preset=0;
					switch (AppState)
					{
					case ST_GENERATOR_1:{
						SettingsItem=0;
						GeneratorMode=GEN_PRIAMUG;
						Freg=20;
						FregPulseWidth=500;
						tim1_init();
						TIM1->DIER|=TIM_DIER_UIE;// TIM_DIER_UIE-Update interrupt enable;
						TIM1->DIER|=TIM_DIER_CC1IE;//TIM_DIER_CC1IE-Capture/Compare 1 interrupt enable;
						NVIC_EnableIRQ(TIM1_UP_TIM16_IRQn);// 
						NVIC_EnableIRQ(TIM1_CC_IRQn);
						}
						break;
					case ST_GENERATOR_2:{
						SettingsItem=0;
						GeneratorMode=GEN_PILA;
						Freg=500;
						tim1_init();
						TIM1->PSC=0;
						TIM1->DIER|=TIM_DIER_UIE;// TIM_DIER_UIE-Update interrupt enable;//TIM1->DIER&=~TIM_DIER_CC1IE;//TIM_DIER_CC1IE-Capture/Compare 1 interrupt enable;
						NVIC_EnableIRQ(TIM1_UP_TIM16_IRQn);//  //NVIC_DisableIRQ(TIM1_CC_IRQn);
						}
						break;
					case ST_GENERATOR_3:{
						SettingsItem=0;
						GeneratorMode=GEN_TREUG;
						Freg=500;
						tim1_init();
						TIM1->PSC=0;
						TIM1->DIER|=TIM_DIER_UIE;// TIM_DIER_UIE-Update interrupt enable;//TIM1->DIER&=~TIM_DIER_CC1IE;//TIM_DIER_CC1IE-Capture/Compare 1 interrupt enable;
						NVIC_EnableIRQ(TIM1_UP_TIM16_IRQn);//  //NVIC_DisableIRQ(TIM1_CC_IRQn);
						}
						break;
					case ST_GENERATOR_4:{
						SettingsItem=0;
						TmpParam[0]=0;
						TmpParam[1]=0;
						tim_dac1_init();
						}
						break;	
					}
					break;
					}
				copy_in_lcdbuff((uint8_t *)str_Priamoug_Pila, 0);
				copy_in_lcdbuff((uint8_t *)str_Treugol_DCplus, 1);
				edit_param(&Preset,1,3);
				if (Preset==0) { LcdBuff[0][0]='>'; LcdBlank[0][0]=_BV(1)|_BV(2)|_BV(3)|_BV(4)|_BV(5)|_BV(6)|_BV(7)|_BV(8); }
				if (Preset==1) { LcdBuff[0][10]='>'; LcdBlank[0][0]=_BV(11)|_BV(12)|_BV(13)|_BV(14); }
				if (Preset==2) { LcdBuff[1][0]='>'; LcdBlank[1][0]=_BV(1)|_BV(2)|_BV(3)|_BV(4)|_BV(5)|_BV(6)|_BV(7)|_BV(8)|_BV(9); }
				if (Preset==3) { LcdBuff[1][11]='>'; LcdBlank[1][0]=_BV(11)|_BV(12)|_BV(13)|_BV(14);}
				}
				break;
			case ST_GENERATOR_1:{//
				if (generator_key(3)) break;
	
				if (Preset==1){
					if (SettingsItem==1){// 
						LcdBlank[0][0]=_BV(9)|_BV(10)|_BV(11)|_BV(12)|_BV(13)|_BV(14)|_BV(15);
						reg_u_job();
						}
					else
					if (SettingsItem==2){//    
						LcdBlank[1][0]=_BV(1)|_BV(2)|_BV(3)|_BV(4)|_BV(5)|_BV(6);
						edit_param(&FregPulseWidth,EncoderSpeed,990);	
						if (FregPulseWidth==0) FregPulseWidth=1;
						}	
					else
					if (SettingsItem==3){// 
						LcdBlank[1][0]=_BV(9)|_BV(10)|_BV(11)|_BV(12)|_BV(13)|_BV(14)|_BV(15);
						edit_param(&Freg,EncoderSpeed,2000);	
						if (Freg<1) Freg=1;
						}	
					if ( Key & (KEY_ENKODER|KEY_ENTER) ) {Preset=0;Key=0;}	
					}
				
				TIM1->ARR=SYSCLK_FREQ/((GENERATOR_PSC+1)*Freg);
				TIM1->CCR1=((float)TIM1->ARR/1000)*FregPulseWidth;
				
				//----display------
				LcdBuff[1][1]='W';
				itoa2(FregPulseWidth,s);
				
				LcdBuff[1][2]=s[2];
				LcdBuff[1][3]=s[1];
				LcdBuff[1][4]='.';
				LcdBuff[1][5]=s[0];
				LcdBuff[1][6]='%';
				
				LcdBuff[1][9]='F';//
				/*itoa2(Freg,s);
				LcdBuff[1][10]=s[3];
				LcdBuff[1][11]=s[2];
				LcdBuff[1][12]=s[1];
				LcdBuff[1][13]=s[0];*/
				itoa_4digit_in_lcdbuf(Freg,1,10);
				LcdBuff[1][14]='H';
				LcdBuff[1][15]='z';
				
				if (SettingsItem==0) LcdBuff[0][0]='>';
				if (SettingsItem==1) LcdBuff[0][8]='>';
				if (SettingsItem==2) LcdBuff[1][0]='>';
				if (SettingsItem==3) LcdBuff[1][8]='>';
				//---------------------------------	
				}
				break;
			case ST_GENERATOR_2://
			case ST_GENERATOR_3:{
				if (generator_key(2)) break;
				
				if (Preset==1){
					if (SettingsItem==1){// 
						LcdBlank[0][0]=_BV(9)|_BV(10)|_BV(11)|_BV(12)|_BV(13)|_BV(14)|_BV(15);
						reg_u_job();
						}
					else
					if (SettingsItem==2){// 
						LcdBlank[1][0]=_BV(9)|_BV(10)|_BV(11)|_BV(12)|_BV(13)|_BV(14)|_BV(15);
						edit_param(&Freg,EncoderSpeed,5000);	
						if (Freg<500) Freg=500;
						}	
					if ( Key & (KEY_ENKODER|KEY_ENTER) ) {Preset=0;Key=0;}	
					}
				
				TIM1->ARR=Freg;
				StepDacPila=(float)DacU/(float)TIM1->ARR;
				//StepDacPila=(float)TIM1->ARR/(float)DacU;

				//----display------

				LcdBuff[1][1]='T';
				LcdBuff[1][2]='I';
				LcdBuff[1][3]='M';
				LcdBuff[1][4]='_';
				LcdBuff[1][5]='A';
				LcdBuff[1][6]='R';
				LcdBuff[1][7]='R';
				
				/*itoa2(Freg,s);
				LcdBuff[1][12]=s[3];
				LcdBuff[1][13]=s[2];
				LcdBuff[1][14]=s[1];
				LcdBuff[1][15]=s[0];*/
				itoa_4digit_in_lcdbuf(Freg,1,12);
				//LcdBuff[1][14]='A';
				//LcdBuff[1][15]='r';
				
				if (SettingsItem==0) LcdBuff[0][0]='>';
				if (SettingsItem==1) LcdBuff[0][8]='>';
				if (SettingsItem==2) LcdBuff[1][11]='>';
				//---------------------------------					
				}	
				break;
			/*case ST_GENERATOR_3:{//
				
				}	
				break;*/
			case ST_GENERATOR_4:{//+..
				if (generator_key(4)) break;
	
				if (Preset==1){
					if (SettingsItem==1){// 
						LcdBlank[0][0]=_BV(9)|_BV(10)|_BV(11)|_BV(12)|_BV(13)|_BV(14)|_BV(15);
						reg_u_job();
						}
					else
					if (SettingsItem==2){// 
						LcdBlank[1][0]=_BV(1)|_BV(2)|_BV(3);
						edit_param(&TmpParam[0],1,2);	
						if (TmpParam[0]==0){
							//DAC->CR&= ~DAC_CR_WAVE1_1;
							//DAC->CR&= ~DAC_CR_MAMP1_3;//triangle wave generation enable
							//DAC->CR&= ~DAC_CR_TEN1;	
							DAC->CR&=~(DAC_CR_WAVE1|DAC_CR_TEN1);//|DAC_CR_MAMP1
							}
						else
						if (TmpParam[0]==1){
							DAC->CR&=~DAC_CR_WAVE1;
							DAC->CR|= DAC_CR_WAVE1_0|DAC_CR_TEN1;
							}
						else
						if (TmpParam[0]==2){
							DAC->CR&=~DAC_CR_WAVE1;
							DAC->CR|= DAC_CR_WAVE1_1|DAC_CR_TEN1;
							}
						}	
					else
					if (SettingsItem==3){// 
						LcdBlank[1][0]=_BV(8)|_BV(9);
						edit_param(&TmpParam[1],1,11);	
						DAC->CR&=~DAC_CR_MAMP1;
						DAC->CR|=TmpParam[1]<<8;
						}	
					else
					if (SettingsItem==4){// 
						LcdBlank[1][0]=_BV(11)|_BV(12)|_BV(13)|_BV(14)|_BV(15);
						edit_param(&Freg,EncoderSpeed,5000);	
						if (Freg<1) Freg=1;
						}	
					if ( Key & (KEY_ENKODER|KEY_ENTER) ) {Preset=0;Key=0;}	
					}
				
				TIMDAC1->ARR=Freg;
				
				//----display------
				if (TmpParam[0]==0){
					LcdBuff[1][1]='H';//
					LcdBuff[1][2]='e';//
					LcdBuff[1][3]=191;//	
					}
				else
				if (TmpParam[0]==1){
					LcdBuff[1][1]=193;//
					LcdBuff[1][2]=121;//
					LcdBuff[1][3]=188;//
					}
				else
				if (TmpParam[0]==2){
					LcdBuff[1][1]='T';//
					LcdBuff[1][2]=112;//
					LcdBuff[1][3]=180;//
				}

	
				LcdBuff[1][5]='A';
				LcdBuff[1][6]='m';
				LcdBuff[1][7]='p';
				itoa2(TmpParam[1],s);
				LcdBuff[1][8]=s[1];
				LcdBuff[1][9]=s[0];
				
				LcdBuff[1][11]='t';
				/*itoa2(Freg,s);
				LcdBuff[1][12]=s[3];
				LcdBuff[1][13]=s[2];
				LcdBuff[1][14]=s[1];
				LcdBuff[1][15]=s[0];*/
				itoa_4digit_in_lcdbuf(Freg,1,12);
				
				if (SettingsItem==0) LcdBuff[0][0]='>';
				if (SettingsItem==1) LcdBuff[0][8]='>';
				if (SettingsItem==2) LcdBuff[1][0]='>';
				if (SettingsItem==3) LcdBuff[1][4]='>';
				if (SettingsItem==4) LcdBuff[1][10]='>';
				//---------------------------------	
				}
				break;
			//----------------------------------------
				
			case ST_CURRENT_PROTECT:{//2   
				if (key_action_exit_state(1, ST_WORK, SO_CURRENT_PROT))	break;
				edit_param(&TrigerCurentProtection,1,1);
				if (TrigerCurentProtection==0) {
					LcdBlank[1][0]=_BV(1)|_BV(2)|_BV(3)|_BV(4)|_BV(5)|_BV(6)|_BV(7); 
					ADC1->CR1&=~ADC_CR1_AWDIE;
					}else {
					LcdBlank[1][0]=_BV(9)|_BV(10)|_BV(11)|_BV(12)|_BV(13)|_BV(14);
					ADC1->CR1|=ADC_CR1_AWDIE;//    ( )
					}
				copy_in_lcdbuff((uint8_t *)&str_SettingsItem[1][1], 0);
				copy_in_lcdbuff((uint8_t *)str_CurentProtect, 1);
				LcdBuff[0][15]=' ';
				}
				break;
				
			case ST_DATA_CRC_ERROR:{//DATA ERROR
				if (key_action_exit_state(0, ST_SETTINGS_ITEM, 0)){
					//strelka=0;
					break;
					}
				LcdBlank[1][0]=_BV(3)|_BV(4)|_BV(5)|_BV(6);
				copy_in_lcdbuff((uint8_t *)str_ErEEP1, 0);
				copy_in_lcdbuff((uint8_t *)str_ErEEP2, 1);
				}
				break;
				
			case ST_RESET_SETTINGS:{//8 RESET SETTINGS

				if (key_action_exit_state(0, ST_SETTINGS_ITEM, 0) ){
					if (Preset==0) reset_settings();
					SettingsItem=SO_RESET;
					AppState=ST_SETTINGS_ITEM;//AppState=ST_WORK;
					break;
					}
				edit_param(&Preset,1,1);
				if (Preset==0) LcdBlank[1][0]=_BV(3)|_BV(4)|_BV(5); else LcdBlank[1][0]=_BV(8)|_BV(9)|_BV(10)|_BV(11);
				copy_in_lcdbuff((uint8_t *)&str_SettingsItem[7][1], 0);
				copy_in_lcdbuff((uint8_t *)str_StoreEsOrNo, 1);
				LcdBuff[0][15]=' ';
				}
				break;
			case ST_ALARM_T:{//     
				if (key_action_exit_state(0, 0, 0) ){
					AppState=ST_WORK;
					EnablePOWER=0;
					break;
					}
				if (TAlarm & _BV(T_VT)) LcdBlank[0][0]=_BV(7)|_BV(8)|_BV(9)|_BV(10); 
				if (TAlarm & _BV(T_TRANS)) LcdBlank[0][0]|=_BV(12)|_BV(13)|_BV(14)|_BV(15);
				display1();
				}
				break;
		}
}


int main(void){
int32_t TimeDisplay=30, TBlank=0, TimeDisableBlank=0, TimeMigBackgr=0;
uint32_t  Tmp, usr=0, Iusr=0, IUsrForProtect=0;
uint8_t  MigBackgrDispleyOn=0;
	
	//clock_init();
//SystemCoreClockUpdate();
	systemtick_init();
	port_init();

	tim_pwm_init();
	timer_delay_init();// 
	tim_init_in_encoder_mode();
	tim_dac1_init();
	
	lcd_init();
	load_user_simvol(0*8, gradus1);
	load_user_simvol(1*8, gradus2);
	ds18b20_init();
	
	dac_init();
	adc_init();
	
	flash_param_read((uint32_t *)&S, (uint8_t *)&S, sizeof(S));
	if (ParamFlashError){
		AppState=ST_DATA_CRC_ERROR;	
		}else{
		Ujob=S.Preset[0][0];
		Ijob=S.Preset[0][1];
		IAdcProtect=(Ijob-S.IkoefB)/S.IkoefA;//Iout=S.IkoefA*(float)AdcI+S.IkoefB;
		ADC1->HTR=IAdcProtect/ADC_OVR-5;
		DacU=((float)Ujob-S.UDackoefB)/S.UDackoefA;
		DacI=((float)Ijob-S.IDackoefB)/S.IDackoefA;
		}
	
while(1){

	if (SysTick->CTRL & SysTick_CTRL_COUNTFLAG_Msk)
		{
//		Test=0; Test=1; Test=0;
		skan_key();
		key_action();
		
		//---------------------------------------------------
		if (EnablePOWER) {
			on(LED_POWER); // 
			TimeAlarmLongPowerOff=0;
			if (TAlarm==0){//   
				if (GeneratorMode==0)
					DAC_U_REGISTR=DacU;//  DAC
				DAC_I_REGISTR=DacI;	
				}else{
				AppState=ST_ALARM_T;// 
				//EnablePOWER=0;
				DAC_U_REGISTR=0;//  DAC
				DAC_I_REGISTR=0;
				}
			}
		else{
			off(LED_POWER); // 
			if (ModeUI==MODE_WORK)	off(LED_MODE_I);
			DAC_U_REGISTR=0;
			DAC_I_REGISTR=0;
			if (++TimeAlarmLongPowerOff>TIME_LONG_POWER_OFF) MigBackgrDispleyOn=1;
			}
		
		//---------------------------------------------------
		if (ModeUI!=MODE_WORK){//      
			if (RotateEnc) TimeModeEnableRegulator=TIME_ENABLE_REGULATOR;
			if (--TimeModeEnableRegulator<0) {
				reset_hold_dac_u();
				ModeUI=MODE_WORK; 
				off(LED_MODE_U);
				off(LED_MODE_I);
				}
			}
		//---------------------------------------------------
		//  ADC
		if (ADC1->SR & ADC_SR_JEOC){
			ADC1->SR &= ~ADC_SR_JEOC;
			AdcUsrU+=ADC1->JDR1;//AdcUsrI+=ADC1->JDR2;
			Tmp=ADC1->JDR2;
			AdcUsrI+=Tmp;
			IUsrForProtect+=Tmp;
			
			if (++usr>=USR_ADC_DATA){
				//  - Y-
				//(X + (Y / 2)) / Y
				AdcU=(AdcUsrU+( (USR_ADC_DATA/ADC_OVR)/2) )/(USR_ADC_DATA/ADC_OVR);
				AdcI=(AdcUsrI+( (USR_ADC_DATA/ADC_OVR)/2 ))/(USR_ADC_DATA/ADC_OVR);
				//AdcU=(AdcUsrU*ADC_OVR+(USR_ADC_DATA/2))/USR_ADC_DATA;
				//AdcI=(AdcUsrI*ADC_OVR+(USR_ADC_DATA/2))/USR_ADC_DATA;
				usr=0;
				AdcUsrU=0;
				AdcUsrI=0;
				}
#define USR_FOR_PROTECT_I	50				
			if (++Iusr>=USR_FOR_PROTECT_I){//    
				Iusr=0;
				//IUsrForProtect=IUsrForProtect/USR_FOR_PROTECT_I;
				IUsrForProtect=(IUsrForProtect*ADC_OVR+(USR_FOR_PROTECT_I/2))/USR_FOR_PROTECT_I;
				if (EnablePOWER)
					if (ModeUI==MODE_WORK){
						if ( IUsrForProtect < IAdcProtect-(ADC_OVR+ADC_OVR/2)){
						//if ( ((IUsrForProtect*ADC_OVR+(USR_FOR_PROTECT_I/2))/USR_FOR_PROTECT_I) < IAdcProtect-5){
							RegulatorCV=1; 
							off(LED_MODE_I);
							}
							else{
							RegulatorCV=0; 
							on(LED_MODE_I);//     off
							}
						}
				IUsrForProtect=0;
				}
			}
			
		//----------------------------
		if (izmerenie_t()){//  DS18B20
			//-------  ----------
			if ((GeneratorMode==0)||(GeneratorMode==GEN_DSPLUS)){//      
				PWM_FAN_VALUE=control_fan(FanPower);//  PWM  
				if (Out1wire & PWIRE_0)
					if ( Temperaturs[T_VT] >= S.TemperEvent[T_VT] ) 		TAlarm|=_BV(T_VT);	
				if (Out1wire & PWIRE_1)
					if ( Temperaturs[T_TRANS] >= S.TemperEvent[T_TRANS] ) 	TAlarm|=_BV(T_TRANS);
				if ( S.TemperEvent[T_VT]-30 >= Temperaturs[T_VT] ) 			TAlarm&=~_BV(T_VT);
				if ( S.TemperEvent[T_TRANS]-30 >= Temperaturs[T_TRANS] ) 	TAlarm&=~_BV(T_TRANS);
				}
			}
		
		//----------------------------------------
		if (FanState & FAN_EVENT_POWER_ON)//  
			{
			if ( --TimeSpinUp<0 ) 	
				{
				FanState&= ~FAN_EVENT_POWER_ON;
				PWM_FAN_VALUE=control_fan(0);
				}
			}
		
		//--------------------------
		//--       - 
		if ( (LcdBlank[0][0] || LcdBlank[1][0]) && (Key==0)){
			if (--TBlank<0){
				if (BlankParam) {
					BlankParam=0;// 
					TBlank=TIM_SHOW_PARAM;//  
					}else{
					BlankParam=1;// 
					TBlank=TIM_BLANK_PARAM;
					}
				}
			}
			else{
			TBlank=1;
			BlankParam=0;
			}
		if (Key & KEY_ROTATE_ENC) TimeDisableBlank=300;
		if (--TimeDisableBlank<0) Key&=~KEY_DISABLE_BLANK;//    
		
		//---------------------------------
		if (--TimeDisplay<=0){//30Hz
			TimeDisplay=30;
			/*if (TimeDisplayReset<=0){// 
				TimeDisplay=TIME_RESET_DISPLAY;
				lcd_init();
				}*/
			lcd_repaint();
			}	
		//--------  ----------------
		//---------------------------------------------------
		if (Key){
			on(PWM_BGLED);
			TimeAlarmLongPowerOff=0;
			MigBackgrDispleyOn=0;
			}
		if (MigBackgrDispleyOn){
			TimeMigBackgr++;
			if (TimeMigBackgr<500)	on(PWM_BGLED);
			else
			if (TimeMigBackgr<1000)	off(PWM_BGLED);		
			else	
			TimeMigBackgr=0;	
			}
		//*************************************************	
		}
	}
}


