#include <stm32f10x.h>

//   
#define MODE_WORK		0
#define MODE_CHANGE_U	1	// 
#define MODE_CHANGE_I	2	// 

//  
#define KEY_POWER			(1<<0)
#define KEY_POWER_LONG		(1<<1)
#define KEY_POWER_UP		(1<<8)
#define KEY_ENKODER			(1<<2)
#define KEY_ENKODER_UP		(1<<3)
#define KEY_ENKODER_LONG	(1<<4)
#define KEY_ENTER			(1<<5)
#define KEY_ENTER_UP		(1<<6)
#define KEY_ENTER_LONG		(1<<7)
#define KEY_ROTATE_ENC		(1<<9)
#define KEY_DISABLE_BLANK	(1<<10)

#define KEY_LONG_TIME		580	//     
#define KEY_SHORT_TIME		10		// 

#define ENCODER_LEFT	1
#define ENCODER_RICHT	2


#define PRESET_COUNT	7	//  (-)



typedef struct {
	uint32_t TLow;
	uint32_t THi;
	uint32_t OnWhenPowerVt;//
	uint32_t ULow;
	uint32_t UHi;
	uint32_t Step;
	uint32_t TimSpinUp;
	uint32_t USpinUp;
	uint32_t OffTLo;
	} FanParam;
	
	
typedef struct {
	FanParam Fan;
	uint32_t TemperEvent[2];
	uint32_t LedLight;
	uint32_t UAdcPoint[2];// 32 int   char!
	uint32_t UDacPoint[2];
	uint32_t USetPoint[2];
	uint32_t IAdcPoint[2];
	uint32_t IDacPoint[2];
	uint32_t ISetPoint[2];
	uint32_t Preset[PRESET_COUNT][2];
	float UkoefA;
	float UkoefB;
	float IkoefA;
	float IkoefB;
	float UDackoefA;
	float UDackoefB;
	float IDackoefA;
	float IDackoefB;
	uint32_t AdcUsr;
	uint32_t Crc;
	}Setting;
	
extern Setting S;
