
#include "stm32f10x.h"

#include "commonfile.h"
#include "one_wire_stm.h"
#include "timers.h"

uint8_t Out1wire;

#define RBYTE_COUNT	4
static uint8_t ReadByteT1w[RBYTE_COUNT];
int32_t ds18B20;
int32_t Temperaturs[KOLVO_DS];



//--------------- 1 Wire DALLAS -----------------

//***********************************************
static uint32_t readbit(void){
uint32_t p=0;	
	//cli();		
	//DDR_1WIRE|=PWIRE_0;
	//DDR_1WIRE|=PWIRE_1;
	//__disable_irq() // Disable Interrupts
	on(DS_PWIRE_0);
	on(DS_PWIRE_1);
	
	delay_us(3);

	off(DS_PWIRE_0);//line up through 1.25us//DDR_1WIRE&=~PWIRE_0;
	off(DS_PWIRE_1);//line up through 1.25us//DDR_1WIRE&=~PWIRE_1;
	
	delay_us(11);

	//p=GPIOx->IDR;
	if (!signal(DS_PWIRE_0)) p=PWIRE_0;
	if (!signal(DS_PWIRE_1)) p|=PWIRE_1;
	//__enable_irq() // Enable Interrupts
	//sei();
	delay_us(47);
	
	return p;

}

//***********************************************
static void readbyte(uint8_t *data) {  
uint32_t p, i, r=1;	
	//DDR_1WIRE&=~PWIRE_0;
	//DDR_1WIRE&=~PWIRE_1;
	//PORT_1WIRE&=~PWIRE_0;
	//PORT_1WIRE&=~PWIRE_1;
	off(DS_PWIRE_0);
	off(DS_PWIRE_1);


	for(i=0; i<8; i++){//8bit
		p=readbit();
		
		if (p & PWIRE_0)	data[0]|=r;
		if (p & PWIRE_1)	data[2]|=r;
		//for(uint8_t j=0; j<KOLVO_DS; j++){//KOLVO_DS
		//	if ( p & PinWireDS[j] ) data[j*2]|=r;
		//	}
		r<<=1;
	}
	off(DS_PWIRE_0);//LINE UP
	off(DS_PWIRE_1);
//	on(DS_POWER_ON);
	//PORT_1WIRE|=Power1w;
	//DDR_1WIRE|=Power1w;

}
//***********************************************
static void writebit0(void){
	//cli();
	//PORT_1WIRE&=~PWIRE_0;
	//PORT_1WIRE&=~PWIRE_1;
	//DDR_1WIRE|=Power1w;//line down
	on(DS_PWIRE_0);//LINE DOWN
	on(DS_PWIRE_1);
	delay_us(60);
	off(DS_PWIRE_0);//LINE UP
	off(DS_PWIRE_1);	
	//PORT_1WIRE|=Power1w;// line up 
	//_delay_us(3);
	//DDR_1WIRE&=~PWIRES;//line up   
	//PORT_1WIRE&=~PWIRES;
	//DDR_1WIRE&=~PWIRE_0;
	//DDR_1WIRE&=~PWIRE_1;
	//PORT_1WIRE&=~PWIRE_0;
	//PORT_1WIRE&=~PWIRE_1;
	//sei();
}
//***********************************************
static void writebit1(void){
	//cli();
	//PORT_1WIRE&=~PWIRE_0;
	//PORT_1WIRE&=~PWIRE_1;
	//DDR_1WIRE|=Power1w;//line down
	on(DS_PWIRE_0);//LINE DOWN
	on(DS_PWIRE_1);	
	delay_us(3);//new
	off(DS_PWIRE_0);//LINE UP
	off(DS_PWIRE_1);	
	//PORT_1WIRE|=Power1w;
	//_delay_us(3);
	//DDR_1WIRE&=~PWIRE_0;
	//DDR_1WIRE&=~PWIRE_1;
	//PORT_1WIRE&=~PWIRE_0;
	//PORT_1WIRE&=~PWIRE_1;
	//sei();
	delay_us(57);
}
//***********************************************
static void writebyte(uint32_t byte){
uint32_t i;
	//DDR_1WIRE&=~PWIRE_0;
	//DDR_1WIRE&=~PWIRE_1;
	//PORT_1WIRE&=~PWIRE_0;
	//PORT_1WIRE&=~PWIRE_1;
	on(DS_PWIRE_0);//LINE DOWN
	on(DS_PWIRE_1);	
//	off(DS_POWER_ON);	
	for(i=0; i<8; i++){
		if (byte&_BV(0)) 
			writebit1();
			else
			writebit0();
		byte>>=1;
		}
	off(DS_PWIRE_0);//LINE UP
	off(DS_PWIRE_1);
//	on(DS_POWER_ON);
	//PORT_1WIRE|=Power1w;
	//DDR_1WIRE|=Power1w;

}
//****************************************

static void detectPresence(void){
uint32_t p=0;//, Out1wire;

	//DDR_1WIRE&=~PWIRE_0;
	//DDR_1WIRE&=~PWIRE_1;
	//PORT_1WIRE&=~PWIRE_0;
	//PORT_1WIRE&=~PWIRE_1;
	off(DS_PWIRE_0);//LINE UP
	off(DS_PWIRE_1);
//	off(DS_POWER_ON);
	Out1wire=PWIRE_0|PWIRE_1;
	on(DS_PWIRE_0);//LINE DOWN
	on(DS_PWIRE_1);	
	//DDR_1WIRE|=PWIRE_0;
	//DDR_1WIRE|=PWIRE_1;
	
	delay_us(480);
	
	//cli();
	//DDR_1WIRE&=~PWIRE_0;
	//DDR_1WIRE&=~PWIRE_1;
	off(DS_PWIRE_0);//LINE UP
	off(DS_PWIRE_1);
	
	delay_us(60);//       
	if (!signal(DS_PWIRE_0)) p=PWIRE_0;
	if (!signal(DS_PWIRE_1)) p|=PWIRE_1;

	if (p &  PWIRE_0) Out1wire&=~PWIRE_0;
	if (p &  PWIRE_1) Out1wire&=~PWIRE_1;
	
	delay_us(300);
	
	//     ,    
	if (signal(DS_PWIRE_0)) Out1wire&=~PWIRE_0;
	if (signal(DS_PWIRE_1)) Out1wire&=~PWIRE_1;
	
}

//****************************************
static void define_ds(void){
	ds18B20=0x00;
	detectPresence();
	writebyte(0x33);//READ ROM [33h]
	readbyte(ReadByteT1w);
	if  (ReadByteT1w[0]==0x28) ds18B20|=PWIRE_0;
	if  (ReadByteT1w[2]==0x28) ds18B20|=PWIRE_1;
}
//****************************************
void ds18b20_init(void){//scratchpad_save

//	pmode(DS_POWER_ON, PIN_CFG_OPP_2MHZ); //   
	pmode(DS_PWIRE_0, PIN_CFG_OOD_2MHZ); //   
	pmode(DS_PWIRE_1, PIN_CFG_OOD_2MHZ); //   
	
	define_ds();
		
	detectPresence();//  
//	Power1w&=ds18B20;
	writebyte(0xCC);//SKIP ROM [CCh]
	writebyte(0x4E);//WRITE SCRATCHPAD [4Eh]
	writebyte(0);//	TH
	writebyte(0);//	TL
	writebyte(0x7F);//	Statys 12bit
		
		/*detectPresence();//   EEPROM
		writebyte(0xCC);//SKIP ROM [CCh]
		writebyte(0x48);//COPY SCRATCHPAD [48h]
		PORT_1WIRE=Power1w;
		DDR_1WIRE=Power1w;*/
}

	
//*******************************************
uint32_t izmerenie_t(void){
static uint32_t State1w, Time1w;
uint32_t  rezult=0, i;
int32_t T;

	switch (State1w)
	{
	case(0)://
		State1w++;
		detectPresence();//  
		break;

	case(1):
//TEST_PIN_SIGN;		
		State1w++;//1.2ms
		writebyte(0xCC);//SKIP ROM [CCh]
		writebyte(0x44);//CONVERT T [44h]
		Time1w=1000;//1.5sek
		//Time1w=100;//1.7sek
//TEST_PIN_SIGN;
		break;

	case(2):
		if (--Time1w==0) State1w++;
		break;

	case(3):// e
		State1w++;
		detectPresence();//
		break;

	case(4):
		State1w++;
		writebyte(0xCC);//SKIP ROM [CCh]
		writebyte(0xBE);//READ SCRATCHPAD [BEh]
		break;

	case(5):
		State1w++;
		readbyte(ReadByteT1w);//  lsb
		break;

	case(6):
		State1w++;
		readbyte(&ReadByteT1w[1]);//  msb
		break;

	case(7):
		State1w++;

		if ( PWIRE_0 & ds18B20 ){
			T=(int32_t)(ReadByteT1w[0]|ReadByteT1w[1]<<8);
			T=T*5/8;
			} else {
			T=(int32_t)(ReadByteT1w[0]|ReadByteT1w[1]<<8);
			T=T*5;
			}
		if (T!=850) Temperaturs[0]=T;//    :-)  ,   85 .
		
		if ( PWIRE_1 & ds18B20 ){
			T=(int32_t)(ReadByteT1w[2]|ReadByteT1w[3]<<8);
			T=T*5/8;
			} else {
			T=(int32_t)(ReadByteT1w[2]|ReadByteT1w[3]<<8);
			T=T*5;
			}
		if (T!=850) Temperaturs[1]=T;//    :-)  ,   85 .
		
		if (( PWIRE_0 & Out1wire )==0) Temperaturs[0]=0;
		if (( PWIRE_1 & Out1wire )==0) Temperaturs[1]=0;
		
		for(i=0; i<RBYTE_COUNT; i++) ReadByteT1w[i]=0;
		
		break;

	case(8):
		State1w=0;
		rezult=1;
		break;
	
	default:
		State1w=0;
		break;
	}
	
	return rezult;
}
//*******************************************
