
#include "timers.h"

#define TIM_PSC_US	(8-1)
#define TIM_PSC_MS	(8000-1)

void timer_delay_init(void){
//*******************  Bit definition for TIM_CR1 register  ********************
//********************  Bit definition for RCC_CR register  ******************** //1680
	//RCC->APB2ENR|=RCC_APB2ENR_TIM17EN;// 
	TIM17->PSC=TIM_PSC_US;//fCK_PSC/(PSC + 1);     PSC=(( ) / ( (1/fCK_PSC)*ARR ))-1
	TIM17->ARR=0xFFFF;//      
	TIM17->EGR|=TIM_EGR_UG;//  
	TIM17->CR1|=TIM_CR1_CEN;// 
}

void delay_us(uint16_t Tim){
	TIM17->CNT=0;
	while(TIM17->CNT < Tim);
}

void delay_ms(uint16_t Tim){
	TIM17->PSC=TIM_PSC_MS;
	TIM17->EGR|=TIM_EGR_UG;//  
	TIM17->CNT=0;
	while(TIM17->CNT < Tim);
	TIM17->PSC=TIM_PSC_US;
	TIM17->EGR|=TIM_EGR_UG;//  
}


void tim_dac1_init(void){
	RCC->APB1ENR|=RCC_APB1ENR_TIM6EN;
	TIMDAC1->PSC=8-1;
	TIMDAC1->ARR=0;//      
	TIMDAC1->CR2|=TIM_CR2_MMS_1;// Update - The update event is selected as a trigger output (TRGO)
	TIMDAC1->EGR|=TIM_EGR_UG;//  
	TIMDAC1->CR1|=TIM_CR1_CEN;// 
}

void tim_dac1_off(void){
	TIMDAC1->CR1&=~TIM_CR1_CEN;//  
	RCC->APB1ENR&=~RCC_APB1ENR_TIM6EN;
}

void tim1_init(void){
	RCC->APB2ENR|=RCC_APB2ENR_TIM1EN;

	TIM1->CCMR1=TIM_CCMR1_OC1M_1|TIM_CCMR1_OC1M_0;//011: Toggle - OC1REF toggles when TIMx_CNT=TIMx_CCR1.
	TIM1->PSC=GENERATOR_PSC;
	TIM1->ARR=200;
	TIM1->CCR1=100;
	TIM1->EGR|=TIM_EGR_UG;//  
	TIM1->CR1|=TIM_CR1_CEN;// 

	//TIM1->DIER|=TIM_DIER_UIE;// TIM_DIER_UIE-Update interrupt enable;
	//TIM1->DIER|=TIM_DIER_CC1IE;//TIM_DIER_CC1IE-Capture/Compare 1 interrupt enable; 
	//NVIC_EnableIRQ(TIM1_UP_TIM16_IRQn);
	//NVIC_EnableIRQ(TIM1_CC_IRQn);
	//TIM1->SR&=~TIM_SR_UIF;//Update interrupt Flag 
	//TIM1->SR&=~TIM_SR_CC1IF;//Capture/Compare 1 interrupt Flag	
	
}

void tim1_off(void){
	TIM1->CR1=0;//stop 
	RCC->APB2ENR&=~RCC_APB2ENR_TIM1EN;
}

void tim_init_in_encoder_mode(void){
// CC1S= 01 (TIMx_CCMR1 register, TI1FP1 mapped on TI1) // CC1S: Capture/Compare 1 selection 01: CC1 channel is configured as input, IC1 is mapped on TI1.
// CC2S= 01 (TIMx_CCMR2 register, TI2FP2 mapped on TI2)//      IC2 .  TI2
// CC1P=0, CC1NP = 0 (TIMx_CCER register, TI1FP1 noninverted, TI1FP1=TI1)
// CC2P=0, CC2NP = 0 (TIMx_CCER register, TI2FP2 noninverted, TI2FP2=TI2)
// SMS= 011 (TIMx_SMCR register, both inputs are active on both rising and falling edges)// SMS: Slave mode selection //011: Encoder mode 3
// CEN= 1 (TIMx_CR1 register, Counter is enabled)
//1    /   
//    4 ,     /__.         ..
//       TIMx_1(2)
//  ,   R
// TIM3_CH1 PA6; TIM3_CH2 PA7;
//   ) 
//     CCMR1- IC1F: Input capture 1 filter
//
	//RCC->APB1ENR|=RCC_APB1ENR_TIM3EN;
	//RCC->APB2ENR|=RCC_APB2ENR_IOPAEN;
//#define T3_CH1	A, 6, H
//#define T3_CH2	A, 7, H
	//pmode(T3_CH1, PIN_CFG_IP);
	//pmode(T3_CH2, PIN_CFG_IP);
	//on(T3_CH1);
	//on(T3_CH2);
	
	TIM3->CCMR1 = TIM_CCMR1_CC1S_0 | TIM_CCMR1_CC2S_0;	//IC1  TI1,IC2  TI2
	TIM3->CCMR1 |=TIM_CCMR1_IC2F | TIM_CCMR1_IC1F;	//  
	TIM3->CCMR1 |=TIM_CCMR1_IC1PSC | TIM_CCMR1_IC2PSC;	//IC1PSC: Input capture  prescaler == 8
	TIM3->CCER	=0;

	TIM3->SMCR  =  TIM_SMCR_SMS_0 ;		// Encoder mode 
	//TIM3->SMCR  = TIM_SMCR_SMS_1 | TIM_SMCR_SMS_0 | TIM_SMCR_ETF;		//011: Encoder mode 3
	//TIM_SMCR_ETF -      

	//TIM3->CCER    = TIM_CCER_CC1P | TIM_CCER_CC2P;
	
	TIM3->ARR	= 0xFFFF;
	TIM3->PSC=0;
	TIM3->CR1   = TIM_CR1_CEN;//Counter enable
	TIM3->EGR|=TIM_EGR_UG;//  
}



